Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 74430)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -5460,7 +6347,7 @@
         }
     }
     
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
+    commit_batch_list(Vcb, &batchlist, Irp);
     
     // If only changing superblock, e.g. changing label, we still need to rewrite
     // the root tree so the generations match, otherwise you won't be able to mount on Linux.
@@ -5483,14 +6370,34 @@
     }
     
     // make sure we always update the extent tree
-    Status = add_root_item_to_cache(Vcb, BTRFS_ROOT_EXTENT, Irp, rollback);
+    Status = add_root_item_to_cache(Vcb, BTRFS_ROOT_EXTENT, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("add_root_item_to_cache returned %08x\n", Status);
         return Status;
     }
     
+    if (Vcb->stats_changed) {
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev = CONTAINING_RECORD(le, device, list_entry);
+            
+            if (dev->stats_changed) {
+                Status = flush_changed_dev_stats(Vcb, dev, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("flush_changed_dev_stats returned %08x\n", Status);
+                    return Status;
+                }
+                dev->stats_changed = FALSE;
+            }
+            
+            le = le->Flink;
+        }
+        
+        Vcb->stats_changed = FALSE;
+    }
+    
     do {
-        Status = add_parents(Vcb, Irp, rollback);
+        Status = add_parents(Vcb, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("add_parents returned %08x\n", Status);
             goto end;
@@ -5526,7 +6433,7 @@
         if (cache_changed)
             ERR("cache has changed, looping again\n");
 #endif
-    } while (cache_changed || !trees_consistent(Vcb, rollback));
+    } while (cache_changed || !trees_consistent(Vcb));
     
 #ifdef DEBUG_WRITE_LOOPS
     ERR("%u loops\n", loops);
@@ -5560,7 +6467,7 @@
         Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
-            int3;
+            goto end;
         }
         
         if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
@@ -5571,12 +6478,13 @@
             Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("error - find_item returned %08x\n", Status);
-                int3;
+                goto end;
             }
             
             if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
                 ERR("error - could not find entry in extent tree for tree at %llx\n", t->header.address);
-                int3;
+                Status = STATUS_INTERNAL_ERROR;
+                goto end;
             }
         }
         
@@ -5586,6 +6494,9 @@
     
     Vcb->superblock.cache_generation = Vcb->superblock.generation;
     
+    if (!Vcb->options.no_barrier)
+        flush_disk_caches(Vcb);
+    
     Status = write_superblocks(Vcb, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("write_superblocks returned %08x\n", Status);
@@ -5592,6 +6503,20 @@
         goto end;
     }
     
+    vde = Vcb->vde;
+    ExAcquireResourceSharedLite(&vde->child_lock, TRUE);
+        
+    le = vde->children.Flink;
+    
+    while (le != &vde->children) {
+        volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
+        
+        vc->generation = Vcb->superblock.generation;
+        le = le->Flink;
+    }
+    
+    ExReleaseResourceLite(&vde->child_lock);
+    
     clean_space_cache(Vcb);
     
     Vcb->superblock.generation++;
@@ -5624,6 +6549,25 @@
     return Status;
 }
 
+NTSTATUS STDCALL do_write(device_extension* Vcb, PIRP Irp) {
+    LIST_ENTRY rollback;
+    NTSTATUS Status;
+    
+    InitializeListHead(&rollback);
+    
+    Status = do_write2(Vcb, Irp, &rollback);
+    
+    if (!NT_SUCCESS(Status)) {
+        ERR("do_write2 returned %08x, dropping into readonly mode\n", Status);
+        Vcb->readonly = TRUE;
+        FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_FORCED_CLOSED);
+        do_rollback(Vcb, &rollback);
+    } else
+        clear_rollback(&rollback);
+    
+    return Status;
+}
+
 #ifdef DEBUG_STATS
 static void print_stats(device_extension* Vcb) {
     ERR("READ STATS:\n");
@@ -5640,6 +6584,8 @@
     ERR("number of overwrites: %llu\n", Vcb->stats.num_overwrites);
     ERR("total time taken: %llu\n", Vcb->stats.overwrite_total_time);
     ERR("number of creates: %llu\n", Vcb->stats.num_creates);
+    ERR("calls to open_fcb: %llu\n", Vcb->stats.open_fcb_calls);
+    ERR("time spent in open_fcb: %llu\n", Vcb->stats.open_fcb_time);
     ERR("total time taken: %llu\n", Vcb->stats.create_total_time);
     
     RtlZeroMemory(&Vcb->stats, sizeof(debug_stats));
@@ -5647,10 +6593,8 @@
 #endif
 
 static void do_flush(device_extension* Vcb) {
-    LIST_ENTRY rollback;
+    NTSTATUS Status;
     
-    InitializeListHead(&rollback);
-    
     FsRtlEnterFileSystem();
 
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
@@ -5660,11 +6604,14 @@
 #endif
 
     if (Vcb->need_write && !Vcb->readonly)
-        do_write(Vcb, NULL, &rollback);
+        Status = do_write(Vcb, NULL);
+    else
+        Status = STATUS_SUCCESS;
     
     free_trees(Vcb);
     
-    clear_rollback(Vcb, &rollback);
+    if (!NT_SUCCESS(Status))
+        ERR("do_write returned %08x\n", Status);
 
     ExReleaseResourceLite(&Vcb->tree_lock);
 
Index: drivers/filesystems/btrfs/free-space.c
===================================================================
--- drivers/filesystems/btrfs/free-space.c	(révision 74430)
+++ drivers/filesystems/btrfs/free-space.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -21,8 +21,6 @@
 // this be a constant number of sectors, a constant 256 KB, or what?
 #define CACHE_INCREMENTS    64
 
-// #define DEBUG_SPACE_LISTS
-
 static NTSTATUS remove_free_space_inode(device_extension* Vcb, UINT64 inode, LIST_ENTRY* batchlist, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
     fcb* fcb;
@@ -45,7 +43,12 @@
     
     fcb->deleted = TRUE;
     
-    flush_fcb(fcb, FALSE, batchlist, Irp, rollback);
+    Status = flush_fcb(fcb, FALSE, batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("flush_fcb returned %08x\n", Status);
+        free_fcb(fcb);
+        return Status;
+    }
     
     free_fcb(fcb);
 
@@ -76,7 +79,11 @@
             break;
         
         if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
-            delete_tree_item(Vcb, &tp, &rollback);
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
             
             if (tp.item->size >= sizeof(FREE_SPACE_ITEM)) {
                 FREE_SPACE_ITEM* fsi = (FREE_SPACE_ITEM*)tp.item->data;
@@ -115,7 +122,7 @@
     Status = STATUS_SUCCESS;
     
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
     
@@ -464,7 +471,7 @@
         return STATUS_INSUFFICIENT_RESOURCES;
     }
     
-    Status = read_file(c->cache, data, 0, c->cache->inode_item.st_size, NULL, NULL, FALSE);
+    Status = read_file(c->cache, data, 0, c->cache->inode_item.st_size, NULL, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("read_file returned %08x\n", Status);
         ExFreePool(data);
@@ -607,7 +614,11 @@
     
     InitializeListHead(&rollback);
     
-    delete_tree_item(Vcb, &tp, &rollback);
+    Status = delete_tree_item(Vcb, &tp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("delete_tree_item returned %08x\n", Status);
+        return Status;
+    }
     
     Status = excise_extents(Vcb, c->cache, 0, c->cache->inode_item.st_size, Irp, &rollback);
     if (!NT_SUCCESS(Status)) {
@@ -616,17 +627,30 @@
         return Status;
     }
     
-    clear_rollback(Vcb, &rollback);
+    clear_rollback(&rollback);
     
     c->cache->deleted = TRUE;
     mark_fcb_dirty(c->cache);
     
-    free_fcb(c->cache);
+    c->old_cache = c->cache;
     c->cache = NULL;
+    
+    le = c->space.Flink;
+    while (le != &c->space) {
+        space* s = CONTAINING_RECORD(le, space, list_entry);
+        LIST_ENTRY* le2 = le->Flink;
+        
+        RemoveEntryList(&s->list_entry);
+        RemoveEntryList(&s->list_entry_size);
+        ExFreePool(s);
+        
+        le = le2;
+    }
+    
     return STATUS_NOT_FOUND;
 }
 
-NTSTATUS load_free_space_cache(device_extension* Vcb, chunk* c, PIRP Irp) {
+static NTSTATUS load_free_space_cache(device_extension* Vcb, chunk* c, PIRP Irp) {
     traverse_ptr tp, next_tp;
     KEY searchkey;
     UINT64 lastaddr;
@@ -724,6 +748,25 @@
     return STATUS_SUCCESS;
 }
 
+NTSTATUS load_cache_chunk(device_extension* Vcb, chunk* c, PIRP Irp) {
+    NTSTATUS Status;
+    
+    if (c->cache_loaded)
+        return STATUS_SUCCESS;
+    
+    Status = load_free_space_cache(Vcb, c, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("load_free_space_cache returned %08x\n", Status);
+        return Status;
+    }
+    
+    protect_superblocks(Vcb, c);
+    
+    c->cache_loaded = TRUE;
+
+    return STATUS_SUCCESS;
+}
+
 static NTSTATUS insert_cache_extent(fcb* fcb, UINT64 start, UINT64 length, LIST_ENTRY* rollback) {
     LIST_ENTRY* le = fcb->Vcb->chunks.Flink;
     chunk* c;
@@ -740,7 +783,7 @@
             ExAcquireResourceExclusiveLite(&c->lock, TRUE);
             
             if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= length) {
-                if (insert_extent_chunk(fcb->Vcb, fcb, c, start, length, FALSE, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, length)) {
+                if (insert_extent_chunk(fcb->Vcb, fcb, c, start, length, FALSE, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, length, FALSE, 0)) {
                     ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
                     return STATUS_SUCCESS;
                 }
@@ -762,7 +805,7 @@
         ExAcquireResourceExclusiveLite(&c->lock, TRUE);
         
         if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= length) {
-            if (insert_extent_chunk(fcb->Vcb, fcb, c, start, length, FALSE, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, length))
+            if (insert_extent_chunk(fcb->Vcb, fcb, c, start, length, FALSE, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, length, FALSE, 0))
                 return STATUS_SUCCESS;
         }
         
@@ -838,8 +881,8 @@
             while (le != &c->cache->extents) {
                 extent* ext = CONTAINING_RECORD(le, extent, list_entry);
                 
-                if (!ext->ignore && (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC)) {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->data->data[0];
+                if (!ext->ignore && (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC)) {
+                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->extent_data.data[0];
                     
                     if (ed2->size != 0) {
                         chunk* c2 = get_chunk_from_address(Vcb, ed2->address);
@@ -863,7 +906,7 @@
         
         // create new inode
         
-        c->cache = create_fcb(PagedPool);
+        c->cache = create_fcb(Vcb, PagedPool);
         if (!c->cache) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
@@ -912,18 +955,27 @@
             return Status;
         }
         
-        if (!keycmp(searchkey, tp.item->key))
-            delete_tree_item(Vcb, &tp, rollback);
+        if (!keycmp(searchkey, tp.item->key)) {
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                ExFreePool(fsi);
+                free_fcb(c->cache);
+                c->cache = NULL;
+                return Status;
+            }
+        }
         
         fsi->key.obj_id = c->cache->inode;
         fsi->key.obj_type = TYPE_INODE_ITEM;
         fsi->key.offset = 0;
         
-        if (!insert_tree_item(Vcb, Vcb->root_root, FREE_SPACE_CACHE_ID, 0, c->offset, fsi, sizeof(FREE_SPACE_ITEM), NULL, Irp, rollback)) {
-            ERR("insert_tree_item failed\n");
+        Status = insert_tree_item(Vcb, Vcb->root_root, FREE_SPACE_CACHE_ID, 0, c->offset, fsi, sizeof(FREE_SPACE_ITEM), NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
             free_fcb(c->cache);
             c->cache = NULL;
-            return STATUS_INTERNAL_ERROR;
+            return Status;
         }
         
         // allocate space
@@ -939,7 +991,13 @@
         c->cache->extents_changed = TRUE;
         InsertTailList(&Vcb->all_fcbs, &c->cache->list_entry_all);
         
-        flush_fcb(c->cache, TRUE, batchlist, Irp, rollback);
+        Status = flush_fcb(c->cache, TRUE, batchlist, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("flush_fcb returned %08x\n", Status);
+            free_fcb(c->cache);
+            c->cache = NULL;
+            return Status;
+        }
         
         *changed = TRUE;
     } else if (realloc_extents) {
@@ -980,8 +1038,8 @@
             while (le != &c->cache->extents) {
                 extent* ext = CONTAINING_RECORD(le, extent, list_entry);
                 
-                if (!ext->ignore && (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC)) {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->data->data[0];
+                if (!ext->ignore && (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC)) {
+                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->extent_data.data[0];
                     
                     if (ed2->size != 0) {
                         chunk* c2 = get_chunk_from_address(Vcb, ed2->address);
@@ -1014,7 +1072,11 @@
         c->cache->inode_item.st_size = new_cache_size;
         c->cache->inode_item.st_blocks = new_cache_size;
         
-        flush_fcb(c->cache, TRUE, batchlist, Irp, rollback);
+        Status = flush_fcb(c->cache, TRUE, batchlist, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("flush_fcb returned %08x\n", Status);
+            return Status;
+        }
     
         *changed = TRUE;
     } else {
@@ -1039,9 +1101,10 @@
             ii = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_ITEM), ALLOC_TAG);
             RtlCopyMemory(ii, &c->cache->inode_item, sizeof(INODE_ITEM));
             
-            if (!insert_tree_item(Vcb, Vcb->root_root, c->cache->inode, TYPE_INODE_ITEM, 0, ii, sizeof(INODE_ITEM), NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
+            Status = insert_tree_item(Vcb, Vcb->root_root, c->cache->inode, TYPE_INODE_ITEM, 0, ii, sizeof(INODE_ITEM), NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                return Status;
             }
             
             *changed = TRUE;
@@ -1066,7 +1129,6 @@
         
         if (keycmp(searchkey, tp.item->key)) {
             ERR("could not find (%llx,%x,%llx) in root_root\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
-            int3;
             return STATUS_INTERNAL_ERROR;
         }
         
@@ -1111,12 +1173,12 @@
         le = le->Flink;
     }
     
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
+    commit_batch_list(Vcb, &batchlist, Irp);
     
     return STATUS_SUCCESS;
 }
 
-static void add_rollback_space(device_extension* Vcb, LIST_ENTRY* rollback, BOOL add, LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c) {
+static void add_rollback_space(LIST_ENTRY* rollback, BOOL add, LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c) {
     rollback_space* rs;
     
     rs = ExAllocatePoolWithTag(PagedPool, sizeof(rollback_space), ALLOC_TAG);
@@ -1131,17 +1193,13 @@
     rs->length = length;
     rs->chunk = c;
     
-    add_rollback(Vcb, rollback, add ? ROLLBACK_ADD_SPACE : ROLLBACK_SUBTRACT_SPACE, rs);
+    add_rollback(rollback, add ? ROLLBACK_ADD_SPACE : ROLLBACK_SUBTRACT_SPACE, rs);
 }
 
-void _space_list_add2(device_extension* Vcb, LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c, LIST_ENTRY* rollback, const char* func) {
+void space_list_add2(LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c, LIST_ENTRY* rollback) {
     LIST_ENTRY* le;
     space *s, *s2;
     
-#ifdef DEBUG_SPACE_LISTS
-    _debug_message(func, "called space_list_add (%p, %llx, %llx, %p)\n", list, address, length, rollback);
-#endif
-    
     if (IsListEmpty(list)) {
         s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
 
@@ -1158,7 +1216,7 @@
             InsertTailList(list_size, &s->list_entry_size);
         
         if (rollback)
-            add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, length, c);
+            add_rollback_space(rollback, TRUE, list, list_size, address, length, c);
         
         return;
     }
@@ -1175,7 +1233,7 @@
         if (address <= s2->address && address + length >= s2->address + s2->size) {
             if (address < s2->address) {
                 if (rollback)
-                    add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, s2->address - address, c);
+                    add_rollback_space(rollback, TRUE, list, list_size, address, s2->address - address, c);
                 
                 s2->size += s2->address - address;
                 s2->address = address;
@@ -1200,7 +1258,7 @@
             
             if (length > s2->size) {
                 if (rollback)
-                    add_rollback_space(Vcb, rollback, TRUE, list, list_size, s2->address + s2->size, address + length - s2->address - s2->size, c);
+                    add_rollback_space(rollback, TRUE, list, list_size, s2->address + s2->size, address + length - s2->address - s2->size, c);
                 
                 s2->size = length;
                 
@@ -1232,7 +1290,7 @@
         // new entry overlaps start of old one
         if (address < s2->address && address + length >= s2->address) {
             if (rollback)
-                add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, s2->address - address, c);
+                add_rollback_space(rollback, TRUE, list, list_size, address, s2->address - address, c);
             
             s2->size += s2->address - address;
             s2->address = address;
@@ -1265,7 +1323,7 @@
         // new entry overlaps end of old one
         if (address <= s2->address + s2->size && address + length > s2->address + s2->size) {
             if (rollback)
-                add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, s2->address + s2->size - address, c);
+                add_rollback_space(rollback, TRUE, list, list_size, address, s2->address + s2->size - address, c);
             
             s2->size = address + length - s2->address;
             
@@ -1303,7 +1361,7 @@
             }
             
             if (rollback)
-                add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, length, c);
+                add_rollback_space(rollback, TRUE, list, list_size, address, length, c);
             
             s->address = address;
             s->size = length;
@@ -1346,10 +1404,10 @@
         order_space_entry(s, list_size);
     
     if (rollback)
-        add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, length, c);
+        add_rollback_space(rollback, TRUE, list, list_size, address, length, c);
 }
 
-static void space_list_merge(device_extension* Vcb, LIST_ENTRY* spacelist, LIST_ENTRY* spacelist_size, LIST_ENTRY* deleting) {
+static void space_list_merge(LIST_ENTRY* spacelist, LIST_ENTRY* spacelist_size, LIST_ENTRY* deleting) {
     LIST_ENTRY* le;
     
     if (!IsListEmpty(deleting)) {
@@ -1357,7 +1415,7 @@
         while (le != deleting) {
             space* s = CONTAINING_RECORD(le, space, list_entry);
             
-            space_list_add2(Vcb, spacelist, spacelist_size, s->address, s->size, NULL);
+            space_list_add2(spacelist, spacelist_size, s->address, s->size, NULL, NULL);
             
             le = le->Flink;
         }
@@ -1375,7 +1433,7 @@
     UINT32* checksums;
     LIST_ENTRY* le;
     
-    space_list_merge(Vcb, &c->space, &c->space_size, &c->deleting);
+    space_list_merge(&c->space, &c->space_size, &c->deleting);
     
     data = ExAllocatePoolWithTag(NonPagedPool, c->cache->inode_item.st_size, ALLOC_TAG);
     if (!data) {
@@ -1415,7 +1473,11 @@
     c->cache->inode_item.sequence++;
     c->cache->inode_item.st_ctime = *now;
     
-    flush_fcb(c->cache, TRUE, batchlist, Irp, rollback);
+    Status = flush_fcb(c->cache, TRUE, batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("flush_fcb returned %08x\n", Status);
+        return Status;
+    }
     
     // update free_space item
     
@@ -1467,7 +1529,7 @@
     
     // write cache
     
-    Status = do_write_file(c->cache, 0, c->cache->inode_item.st_size, data, NULL, rollback);
+    Status = do_write_file(c->cache, 0, c->cache->inode_item.st_size, data, NULL, FALSE, 0, rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("do_write_file returned %08x\n", Status);
         return Status;
@@ -1506,12 +1568,12 @@
         le = le->Flink;
     }
     
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
+    commit_batch_list(Vcb, &batchlist, Irp);
     
     return STATUS_SUCCESS;
 }
 
-void _space_list_add(device_extension* Vcb, chunk* c, BOOL deleting, UINT64 address, UINT64 length, LIST_ENTRY* rollback, const char* func) {
+void space_list_add(device_extension* Vcb, chunk* c, BOOL deleting, UINT64 address, UINT64 length, LIST_ENTRY* rollback) {
     LIST_ENTRY* list;
     
     TRACE("(%p, %p, %u, %llx, %llx, %p)\n", Vcb, c, deleting, address, length, rollback);
@@ -1521,17 +1583,13 @@
     if (!c->list_entry_changed.Flink)
         InsertTailList(&Vcb->chunks_changed, &c->list_entry_changed);
     
-    _space_list_add2(Vcb, list, deleting ? NULL : &c->space_size, address, length, c, rollback, func);
+    space_list_add2(list, deleting ? NULL : &c->space_size, address, length, c, rollback);
 }
 
-void _space_list_subtract2(device_extension* Vcb, LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c, LIST_ENTRY* rollback, const char* func) {
+void space_list_subtract2(LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c, LIST_ENTRY* rollback) {
     LIST_ENTRY *le, *le2;
     space *s, *s2;
     
-#ifdef DEBUG_SPACE_LISTS
-    _debug_message(func, "called space_list_subtract (%p, %llx, %llx, %p)\n", list, address, length, rollback);
-#endif
-    
     if (IsListEmpty(list))
         return;
     
@@ -1545,7 +1603,7 @@
         
         if (s2->address >= address && s2->address + s2->size <= address + length) { // remove entry entirely
             if (rollback)
-                add_rollback_space(Vcb, rollback, FALSE, list, list_size, s2->address, s2->size, c);
+                add_rollback_space(rollback, FALSE, list, list_size, s2->address, s2->size, c);
             
             RemoveEntryList(&s2->list_entry);
             
@@ -1556,7 +1614,7 @@
         } else if (address + length > s2->address && address + length < s2->address + s2->size) {
             if (address > s2->address) { // cut out hole
                 if (rollback)
-                    add_rollback_space(Vcb, rollback, FALSE, list, list_size, address, length, c);
+                    add_rollback_space(rollback, FALSE, list, list_size, address, length, c);
                 
                 s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
 
@@ -1581,7 +1639,7 @@
                 return;
             } else { // remove start of entry
                 if (rollback)
-                    add_rollback_space(Vcb, rollback, FALSE, list, list_size, s2->address, address + length - s2->address, c);
+                    add_rollback_space(rollback, FALSE, list, list_size, s2->address, address + length - s2->address, c);
                 
                 s2->size -= address + length - s2->address;
                 s2->address = address + length;
@@ -1593,7 +1651,7 @@
             }
         } else if (address > s2->address && address < s2->address + s2->size) { // remove end of entry
             if (rollback)
-                add_rollback_space(Vcb, rollback, FALSE, list, list_size, address, s2->address + s2->size - address, c);
+                add_rollback_space(rollback, FALSE, list, list_size, address, s2->address + s2->size - address, c);
             
             s2->size = address - s2->address;
             
@@ -1607,7 +1665,7 @@
     }
 }
 
-void _space_list_subtract(device_extension* Vcb, chunk* c, BOOL deleting, UINT64 address, UINT64 length, LIST_ENTRY* rollback, const char* func) {
+void space_list_subtract(device_extension* Vcb, chunk* c, BOOL deleting, UINT64 address, UINT64 length, LIST_ENTRY* rollback) {
     LIST_ENTRY* list;
     
     list = deleting ? &c->deleting : &c->space;
@@ -1615,5 +1673,5 @@
     if (!c->list_entry_changed.Flink)
         InsertTailList(&Vcb->chunks_changed, &c->list_entry_changed);
     
-    _space_list_subtract2(Vcb, list, deleting ? NULL : &c->space_size, address, length, c, rollback, func);
+    space_list_subtract2(list, deleting ? NULL : &c->space_size, address, length, c, rollback);
 }
